local isInit = true;
local isRaid = true;
local isMinimized = false;
local isEnabled = false;

local tDebuff = GetTime();

local cDebuffs = { };
local cButton = { };

local sSpell1 = nil;
local sSpell2 = nil;

function MM_DiSpell_Msg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg .. "|r");
end

function MM_DiSpell_OnEvent(self, event, ...)
	if (event == "PLAYER_ENTERING_WORLD") then
        MM_DiSpell_OnPlayerEnteringWorld();
	elseif (event == "PLAYER_REGEN_ENABLED") then
        MM_DiSpell_OnPlayerRegenEnabled();
	elseif (event == "UNIT_PET" or event == "UNIT_NAME_UPDATE") then
        MM_DiSpell_SetButtons();
	elseif (event == "RAID_ROSTER_UPDATE" or event == "PARTY_MEMBERS_CHANGED") then
        MM_DiSpell_OnPartyUpdate();
	end
end

function MM_DiSpell_OnUpdate(elapsed)
	if (not isInit) then
		if GetTime() < tDebuff + 0.33 then
			return;
		end
		tDebuff = GetTime();
		MM_DiSpell_CheckDebuffs();
	end
end

function MM_DiSpell_OnPlayerEnteringWorld()
    isInit = false;
    MM_DiSpell_SetSpells();
    if (not InCombatLockdown()) then
        MM_DiSpell_SetButtons();
    end
end

function MM_DiSpell_OnPlayerRegenEnabled()
    if (not InCombatLockdown()) then
        MM_DiSpell_SetButtons();
    end
end

function MM_DiSpell_OnUnitUpdate()
    if (not InCombatLockdown()) then
        MM_DiSpell_SetButtons();
    end
end

function MM_DiSpell_OnPartyUpdate()
    if (not InCombatLockdown()) then
        MM_DiSpell_SetButtons();
    end
end

function MM_DiSpell_OnMouseDown(self,button) 
    if button == "LeftButton" then
        self:StartMoving();
    end
end

function MM_DiSpell_OnMouseUp(self,button) 
    if button == "LeftButton" then
        self:StopMovingOrSizing();
    end
end

function MM_DiSpell_InitButtons()
	local frame = getglobal("MM_DiSpell_Frame");

	local idx = 1;
	local sp = 0;
	local ln = 0;
	local i = 0;

	for j = 0, 39, 1 do
		if (j > 0 and math.fmod(j, 5) == 0) then
			sp = sp + 2;
		end
		if (j > 0 and math.fmod(j, 10) == 0) then
			ln = ln + 1;
			sp = 0;
			i = 0;
		end

		local button = CreateFrame("Button", "MM_DiSpell_Frame_Button"..idx, frame, "SecureActionButtonTemplate");
		button:SetWidth(16);
		button:SetHeight(16);
		button:SetBackdrop({bgFile = "Interface\\Buttons\\White8x8", tile=true, tileSize = 8});
		button:SetAlpha(1);
		button:SetNormalFontObject("GameFontHighlightSmall");
		button:SetHighlightFontObject("GameFontHighlightSmall");
		button:SetPoint("TOPLEFT", frame, "TOPLEFT", 4 + i * 16 + i * 2 + sp, -16 + ln * -20);
      
		button:EnableMouse(true);
		button:RegisterForClicks("LeftButtonUp", "RightButtonUp");
      
		button:SetAttribute("unit", nil);
		button:SetAttribute("type1", "spell");
		button:SetAttribute("type2", "spell");
		button:SetAttribute("type3", "target");
		button:SetAttribute("spell1", nil);
		button:SetAttribute("spell2", nil);
      
		MM_DiSpell_SetDebuff(nil, idx, -1);

		idx = idx + 1;
		i = i + 1;
	end

	idx = 1;
	sp = 0;
	ln = 0;
	i = 0;
	for j = 0, 19, 1 do
		if (j > 0 and math.fmod(j, 5) == 0) then
			sp = sp + 2;
		end
      		if (j > 0 and math.fmod(j, 10) == 0) then
			ln = ln + 1;
			sp = 0;
			i = 0;
		end
      
		local button = CreateFrame("Button", "MM_DiSpell_Frame_PetButton"..idx, frame, "SecureActionButtonTemplate");
		button:SetWidth(16);
		button:SetHeight(16);
		button:SetBackdrop({bgFile = "Interface\\Buttons\\White8x8", tile=true, tileSize = 8});
		button:SetAlpha(1);
		button:SetNormalFontObject("GameFontHighlightSmall");
		button:SetHighlightFontObject("GameFontHighlightSmall");
		button:SetPoint("TOPLEFT", frame, "TOPLEFT", 4 + i * 16 + i * 2 + sp, -98 + ln * -20);

		button:EnableMouse(true);
		button:RegisterForClicks("LeftButtonUp", "RightButtonUp");
      
		button:SetAttribute("unit", nil);
		button:SetAttribute("type1", "spell");
		button:SetAttribute("type2", "spell");
		button:SetAttribute("type3", "target");
		button:SetAttribute("spell1", nil);
		button:SetAttribute("spell2", nil);
      
		MM_DiSpell_SetPetDebuff(nil, idx, -1);
      
		idx = idx + 1;
		i = i + 1;
	end
end

function MM_DiSpell_Minimize()
	local frame = getglobal("MM_DiSpell_Frame");
	if (not InCombatLockdown()) then
		if (isMinimized) then
			isMinimized = false;
			frame:SetHeight(138);
			MM_DiSpell_SetButtons();
		else
			isMinimized = true;
			frame:SetHeight(18);
			MM_DiSpell_HideButtons();
		end
	end
end

function MM_DiSpell_HideButtons()
	local btn;
	local i
	for i = 1, 40, 1 do
		btn = getglobal("MM_DiSpell_Frame_Button"..i);
		btn:Hide();
	end
	for i = 1, 20, 1 do
		btn = getglobal("MM_DiSpell_Frame_PetButton"..i);
		btn:Hide();
	end
end

function MM_DiSpell_SetSpells()
	cDebuffs = { };
	local _, englishClass = UnitClass("player");
	local iMacro = nil;
	if (englishClass == "DRUID") then
        isEnabled = true;
		cDebuffs[MM_DISPELL_DISEASE] = nil;
		cDebuffs[MM_DISPELL_MAGIC] = 1;
		cDebuffs[MM_DISPELL_POISON] = 1;
		cDebuffs[MM_DISPELL_CURSE] = 1;
		sSpell1 = MM_DISPELL_REMOVECORRUPTION;
		sSpell2 = nil;
		iMacro = GetMacroIndexByName("DiDruid");
		if (iMacro == 0) then
			iMacro = CreateMacro("DiDruid", 1, "/cast "..MM_DISPELL_REMOVECORRUPTION.."\n/targetraid", 1, 1);
		else
			EditMacro(iMacro, "DiDruid", 1, "/cast "..MM_DISPELL_REMOVECORRUPTION.."\n/targetraid", 1);
		end
	elseif (englishClass == "PALADIN") then
        isEnabled = true;
		cDebuffs[MM_DISPELL_DISEASE] = 1;
		cDebuffs[MM_DISPELL_MAGIC] = 1;
		cDebuffs[MM_DISPELL_POISON] = 1;
		cDebuffs[MM_DISPELL_CURSE] = nil;
		sSpell1 = MM_DISPELL_CLEANSE;
		sSpell2 = nil;
		iMacro = GetMacroIndexByName("DiCleanse");
		if (iMacro == 0) then
			iMacro = CreateMacro("DiCleanse", 1, "/cast "..MM_DISPELL_CLEANSE.."\n/targetraid", 1, 1);
		else
			EditMacro(iMacro, "DiCleanse", 1, "/cast "..MM_DISPELL_CLEANSE.."\n/targetraid", 1);
		end
	elseif (englishClass == "PRIEST") then
        isEnabled = true;
		cDebuffs[MM_DISPELL_DISEASE] = 2;
		cDebuffs[MM_DISPELL_MAGIC] = 1;
		cDebuffs[MM_DISPELL_POISON] = nil;
		cDebuffs[MM_DISPELL_CURSE] = nil;
		sSpell1 = MM_DISPELL_DISPELLMAGIC;
		sSpell2 = MM_DISPELL_CUREDISEASE;
		iMacro = GetMacroIndexByName("DiMagic");
		if (iMacro == 0) then
			iMacro = CreateMacro("DiMagic", 1, "/cast "..MM_DISPELL_DISPELLMAGIC.."\n/targetraid", 1, 1);
		else
			EditMacro(iMacro, "DiMagic", 1, "/cast "..MM_DISPELL_DISPELLMAGIC.."\n/targetraid", 1);
		end
		iMacro = GetMacroIndexByName("DiDisease");
		if (iMacro == 0) then
			iMacro = CreateMacro("DiDisease", 1, "/cast "..MM_DISPELL_DISPELLMAGIC.."\n/targetraid", 1, 1);
		else
			EditMacro(iMacro, "DiDisease", 1, "/cast "..MM_DISPELL_DISPELLMAGIC.."\n/targetraid", 1);
		end
	elseif (englishClass == "SHAMAN") then
        isEnabled = true;
		cDebuffs[MM_DISPELL_DISEASE] = nil;
		cDebuffs[MM_DISPELL_MAGIC] = nil;
		cDebuffs[MM_DISPELL_POISON] = nil;
		cDebuffs[MM_DISPELL_CURSE] = 1;
		sSpell1 = MM_DISPELL_CLEANSESPIRIT;
		sSpell2 = nil;
		iMacro = GetMacroIndexByName("DiCleanseSpirit");
		if (iMacro == 0) then
			iMacro = CreateMacro("DiCleanseSpirit", 1, "/cast "..MM_DISPELL_CLEANSESPIRIT.."\n/targetraid", 1, 1);
		else
			EditMacro(iMacro, "DiCleanseSpirit", 1, "/cast "..MM_DISPELL_CLEANSESPIRIT.."\n/targetraid", 1);
		end
	elseif (englishClass == "MAGE") then
        isEnabled = true;
		cDebuffs[MM_DISPELL_DISEASE] = nil;
		cDebuffs[MM_DISPELL_MAGIC] = nil;
		cDebuffs[MM_DISPELL_POISON] = nil;
		cDebuffs[MM_DISPELL_CURSE] = 1;
		sSpell1 = MM_DISPELL_REMOVECURSE;
		sSpell2 = nil;
		iMacro = GetMacroIndexByName("DiCurse");
		if (iMacro == 0) then
			iMacro = CreateMacro("DiCurse", 1, "/cast "..MM_DISPELL_REMOVECURSE.."\n/targetraid", 1, 1);
		else
			EditMacro(iMacro, "DiCurse", 1, "/cast "..MM_DISPELL_REMOVECURSE.."\n/targetraid", 1);
		end
    else
        isEnabled = false;
		cDebuffs[MM_DISPELL_DISEASE] = nil;
		cDebuffs[MM_DISPELL_MAGIC] = nil;
		cDebuffs[MM_DISPELL_POISON] = nil;
		cDebuffs[MM_DISPELL_CURSE] = nil
		sSpell1 = nil;
		sSpell2 = nil;
	end
end

function MM_DiSpell_SetButtons()
	local frame = getglobal("MM_DiSpell_Frame");
	local nMax = GetNumRaidMembers();
	if (nMax == 0) then
		isRaid = false;
	else
		isRaid = true;
	end
	
	local i, idx;
	
	if (isRaid) then
		local iGroup, iSubGroup;
		local cCount = { };
		cCount[1] = 0;
		cCount[2] = 0;
		cCount[3] = 0;
		cCount[4] = 0;
		cCount[5] = 0;
		cCount[6] = 0;
		cCount[7] = 0;
		cCount[8] = 0;
		
		cButton = { };

		for i = 1, nMax, 1 do
			sName, _, iSubGroup, _, _, _, _, _, _ = GetRaidRosterInfo(i);
			cCount[iSubGroup] = cCount[iSubGroup] + 1;
			idx = ((iSubGroup * 5) + cCount[iSubGroup]) - 5;
			cButton["raid"..i] = idx;
			MM_DiSpell_SetButton("raid"..i, idx, sSpell1, sSpell2);
		end
		for iGroup = 1, 8, 1 do
			iSubGroup = cCount[iGroup] + 1;
			for i = iSubGroup, 5, 1 do
				idx = ((iGroup * 5) + i) - 5;
				MM_DiSpell_SetButton(nil, idx, nil, nil);
			end
		end

		idx = 1;
		for i = 1, nMax, 1 do
			if UnitExists("raidpet"..i) then
				MM_DiSpell_SetPetButton("raidpet"..i, idx, sSpell1, sSpell2);
				idx = idx + 1;
			end
		end
		for i = idx, 20, 1 do
			MM_DiSpell_SetPetButton(nil, i, nil, nil);
		end
	else
		MM_DiSpell_SetButton("player", 1, sSpell1, sSpell2);
		idx = 2;
		for i = 1, 4, 1 do
			if UnitExists("party"..i) then
				MM_DiSpell_SetButton("party"..i, idx, sSpell1, sSpell2);
				idx = idx + 1;
			end
		end
		for i = idx, 40, 1 do
			MM_DiSpell_SetButton(nil, i, nil, nil);
		end

		idx = 1;
        if UnitExists("pet") then
            MM_DiSpell_SetPetButton("pet", idx, sSpell1, sSpell2);
            idx = idx + 1;
        end
		for i = 1, 4, 1 do
			if UnitExists("party"..i.."pet") then
				MM_DiSpell_SetPetButton("party"..i.."pet", idx, sSpell1, sSpell2);
				idx = idx + 1;
			end
		end
		for i = idx, 20, 1 do
			MM_DiSpell_SetPetButton(nil, i, nil, nil);
		end
	end
end

function MM_DiSpell_SetButton(unit, idx, spell1, spell2)
	local btn;
	btn = getglobal("MM_DiSpell_Frame_Button"..idx);

	btn:SetAttribute("unit", unit);
	btn:SetAttribute("spell1", spell1);
	btn:SetAttribute("spell2", spell2);

	if (unit) then
		btn:SetText(idx);
		if (not isMinimized) then
			btn:Show();
		end
	else
		btn:Hide();
	end
end

function MM_DiSpell_SetPetButton(unit, idx, spell1, spell2)
	local btn;
	btn = getglobal("MM_DiSpell_Frame_PetButton"..idx);
  
	btn:SetAttribute("unit", unit);
	btn:SetAttribute("spell1", spell1);
	btn:SetAttribute("spell2", spell2);
  
	if (unit) then
		btn:SetText(string.char(64 + idx));
		if (not isMinimized) then
			btn:Show();
		end
	else
		btn:Hide();
	end
end

function MM_DiSpell_SetDebuff(unit, idx, nr)
	local btn;
	if (not idx) then
		return;
	end

	btn = getglobal("MM_DiSpell_Frame_Button"..idx);
	if (not btn) then
		return;
	end

	if (nr == 0) then
		btn:SetBackdropColor(0.25, 0.25, 0.25, 1);
		btn:SetAlpha(0.5);
	elseif (nr == 1) then
		btn:SetBackdropColor(1, 0, 0, 1);
		btn:SetAlpha(1.0);
	elseif (nr == 2) then
		btn:SetBackdropColor(0, 0, 1, 1);
		btn:SetAlpha(1.0);
	elseif (nr == 3) then
		btn:SetBackdropColor(1, 0, 0, 1);
		btn:SetAlpha(0.1);
	elseif (nr == 4) then
		btn:SetBackdropColor(0, 0, 1, 1);
		btn:SetAlpha(0.1);
	else
		btn:SetBackdropColor(0.25, 0.25, 0.25, 1);
		btn:SetAlpha(0.1);
	end
end

function MM_DiSpell_SetPetDebuff(unit, idx, nr)
	local btn;
	btn = getglobal("MM_DiSpell_Frame_PetButton"..idx);

	if (not btn) then
		return;
	end
  
	if (nr == 0) then
		btn:SetBackdropColor(0.25, 0.25, 0.25, 1);
		btn:SetAlpha(0.5);
	elseif (nr == 1) then
		btn:SetBackdropColor(1, 0, 0, 1);
		btn:SetAlpha(1.0);
	elseif (nr == 2) then
		btn:SetBackdropColor(0, 0, 1, 1);
		btn:SetAlpha(1.0);
	elseif (nr == 3) then
		btn:SetBackdropColor(1, 0, 0, 1);
		btn:SetAlpha(0.1);
	elseif (nr == 4) then
		btn:SetBackdropColor(0, 0, 1, 1);
		btn:SetAlpha(0.1);
	else
		btn:SetBackdropColor(0.25, 0.25, 0.25, 1);
		btn:SetAlpha(0.1);
	end
end

function MM_DiSpell_CheckDebuffs()
	local nMax = GetNumRaidMembers();
	local i, idx;

	if (isRaid) then
		for i = 1, nMax, 1 do
			MM_DiSpell_CheckUnitDebuffs("raid"..i, cButton["raid"..i]);
		end
    
		i = 1;
		idx = 1;
		for i = 1, nMax, 1 do
			if UnitPlayerOrPetInRaid("raidpet"..i) then
				MM_DiSpell_CheckPetUnitDebuffs("raidpet"..i, idx);
				idx = idx + 1
			end
		end
	else
		MM_DiSpell_CheckUnitDebuffs("player", 1);
		idx = 2;
		for i = 1, 4, 1 do
			MM_DiSpell_CheckUnitDebuffs("party"..i, idx);
			idx = idx + 1
		end
    
		i = 1;
		idx = 1;
        if UnitPlayerOrPetInParty("pet") then
            MM_DiSpell_CheckPetUnitDebuffs("pet"..i, idx);
            idx = idx + 1
        end
		for i = 1, 4, 1 do
			if UnitPlayerOrPetInParty("party"..i.."pet") then
				MM_DiSpell_CheckPetUnitDebuffs("party"..i.."pet", idx);
				idx = idx + 1
			end
		end
	end
end

function MM_DiSpell_CheckUnitDebuffs(unit, idx)
	local name, dtype, uclass, inRange;
    inRange = false;
    foundOne = false;
	if (UnitExists(unit) and UnitIsVisible(unit) and UnitIsFriend("player", unit)) then
        if (isEnabled) then
            if IsSpellInRange(sSpell1, unit) == 1 then
                inRange = true;
            end
        else
            inRange = CheckInteractDistance(unit, 4);
        end
        n = 1;
        while (true) do
            name, _, icon, _, dtype = UnitDebuff(unit, n, 1);
            if (not icon) then
                break;
            end
            if (name and dtype) then
                if (cDebuffs[dtype] and not UnitCanAttack("player", unit)) then
                    if (inRange) then
                        MM_DiSpell_SetDebuff(unit, idx, cDebuffs[dtype]);
                        foundone = true;
                        return;
                    else
                        MM_DiSpell_SetDebuff(unit, idx, cDebuffs[dtype] + 2);
                        foundone = true;
                        return;
                    end
                end
            end
            n = n + 1;
        end
        if (inRange) then
            MM_DiSpell_SetDebuff(unit, idx, 0);
        else
            MM_DiSpell_SetDebuff(unit, idx, -1);
        end
        return;
	end
    MM_DiSpell_SetDebuff(unit, idx, -1);
end

function MM_DiSpell_CheckPetUnitDebuffs(unit, idx)  
	local name, dtype, uclass, inRange;
    inRange = false;
    foundOne = false;
	if (UnitExists(unit) and UnitIsVisible(unit) and UnitIsFriend("player", unit)) then
        if (isEnabled) then
            if IsSpellInRange(sSpell1, unit) == 1 then
                inRange = true;
            end
        else
            inRange = CheckInteractDistance(unit, 4);
        end
        n = 1;
        while (true) do
            name, _, icon, _, dtype = UnitDebuff(unit, n);
            if (not icon) then
                break;
            end
            if (name and dtype) then
                if (cDebuffs[dtype] and not UnitCanAttack("player", unit)) then
                    if (inRange) then
                        MM_DiSpell_SetPetDebuff(unit, idx, cDebuffs[dtype]);
                        foundone = true;
                        return;
                    else
                        MM_DiSpell_SetPetDebuff(unit, idx, cDebuffs[dtype] + 2);
                        foundone = true;
                        return;
                    end
                end
            end
            n = n + 1;
        end
        if (inRange) then
            MM_DiSpell_SetPetDebuff(unit, idx, 0);
        else
            MM_DiSpell_SetPetDebuff(unit, idx, -1);
        end
        return;
	end
    MM_DiSpell_SetPetDebuff(unit, idx, -1);
end
